<?php
/**
 * @copyright (c) Kufer Software GmbH, Oderstraße 7, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Firma\KursUebersicht\Detailsreiter\Teilnehmer;

use Kufer\Web\KuferTools\Utils\DatamodulHelper\Belegungen\BelegungsHelper;
use Kufer\Web\KuferTools\Utils\DatamodulHelper\Belegungen\FirmaBelegungen;
use Kufer\Web\KuferTools\Utils\DatamodulHelper\Belegungen\FirmaReiterTeilnehmerBelegungen;

class TeilnehmerUseCase extends \Kufer\Web\KuferTools\Basis\Kursdetails\Detailsreiter\Teilnehmer\TeilnehmerUseCase
{
  public function __construct($request)
  {
    parent::__construct($request, new TeilnehmerResponse());
  }

  public static function getToolId()
  {
    return \ToolsAPI::TOOL_KURSUEBERSICHT_FA;
  }

  public static function getToolSectionId()
  {
    return 771;
  }

  protected function getMainReiterId()
  {
    return 336;
  }

  protected function getMainReiterIdSection(): int
  {
    return 10;
  }

  protected function getRequestedId()
  {
    return $this->request->belegId;
  }

  public function getKurs($knr)
  {
    $belegung = (new FirmaBelegungen($this->toolSettings, $this->getUser()->tnr))->getDatamodulById($this->request->belegId);

    return parent::getKurs($belegung->knr);
  }

  protected function getAllowedIds()
  {
    return (new FirmaBelegungen($this->toolSettings, $this->getUser()->tnr))->getIdsOhneFilter();
  }

  protected function getBelegungsHelper(\Kurs $kurs): BelegungsHelper
  {
    return new FirmaReiterTeilnehmerBelegungen($this->toolSettings, $this->request, $kurs->id, $this->getUser()->tnr);
  }

  protected function getButtons()
  {
    $buttonsObj = new \Kufer\Web\KuferTools\Basis\Kursdetails\Detailsreiter\FaTeilnehmerReiterButtons($this, $this->request, $this->response);
    $buttonsArray = $buttonsObj->getButtons();
    $selectionDependentButtons = array('E-Mail', 'SMS');
    $this->response->markierenButtons = $this->markierenButtonNotwendig($buttonsArray, $selectionDependentButtons);

    return $buttonsArray;
  }

  protected function getResponse($kurs, $belegungen, $belegungenOhneFilter)
  {
    parent::getResponse($kurs, $belegungen, $belegungenOhneFilter);
    $this->response->changedBelegungen = $this->request->changedBelegungen;
    $this->response->statusMessage = $this->request->statusMessage;
    $this->response->belegung = \DBWorkBelegung::getDefaultInstance()->getBelegung($this->request->belegId);

    return $this->response;
  }
}

class TeilnehmerRequest extends \Kufer\Web\KuferTools\Basis\Kursdetails\Detailsreiter\Teilnehmer\TeilnehmerRequest
{
  public $changedBelegungen;
  public $statusMessage;
  public $belegId;
}

class TeilnehmerResponse extends \Kufer\Web\KuferTools\Basis\Kursdetails\Detailsreiter\Teilnehmer\TeilnehmerResponse
{
  public $changedBelegungen;
  public $statusMessage;
  public $belegung;
}